<?php

$mgrm_alaune		= new mgrm_alaune;

class mgrm_alaune {
	
	var $slug			= "alaune";
	var $imgmaxw		= 1170;
	var $imgmaxh		= 340;
	
	var $box_title		= "Vidéo & image à la une";
	
	var $video_label	= "Vidéo";
	var $video_info		= "Url Youtube. Ex : https://www.youtube.com/watch?v=mACDvq2Oty0";
	
	var $image_label	= "Image";
	var $image_select	= "Sélectionner une image";
	var $image_del		= "Retirer l'image";
	
	// Construction de la classe
	function __construct()
	{
		global $mgrm_lng;
		
		// Traductions
		$cur_lng	= substr( get_locale(), 0, 2 );
		
		if ( $cur_lng == "nl" )
		{
			$this->box_title	= "Video & afbeelding op de top";
	
			$this->video_label	= "Video";
			$this->video_info	= "Youtube Url. Ex : https://www.youtube.com/watch?v=mACDvq2Oty0";
			
			$this->image_label	= "Afbeelding";
			$this->image_select	= "Selecteer de afbeelding";
			$this->image_del	= "Afbeeldingen verwijderen";
		}
		
		add_action( 'add_meta_boxes', array( $this, 'add_meta_box' ) );
		add_action( 'edit_form_after_title', array( $this,  'move_box' ) );
		add_action( 'save_post', array( $this, 'save_meta' ) );
		add_action( 'after_setup_theme', array( $this, 'thumbnail_size' ) );

		if ( is_admin() )
		{
			add_action( "admin_head", array( $this, "add_css" ) );
			add_action( 'admin_enqueue_scripts', array( $this, 'admin_js_css' ) );
		}
	}
	
	
	// Ajouter les champ pour la vidéo/image à la une
	function add_meta_box()
	{
		add_meta_box( 'mgrm_alaune', $this->box_title, array( $this, 'display_form' ), 'post', 'mgrm_alaune', 'high' );
		add_meta_box( 'mgrm_alaune', $this->box_title, array( $this, 'display_form' ), 'page', 'mgrm_alaune', 'high' );
	}
	
	
	// Affichage du formulaire
	function display_form( $post )
	{	
		// Video
		$vid_url	= get_post_meta( $post->ID, '_mgrm_alaune_video', true );
		
		// Image
		$img_id		= get_post_meta( $post->ID, '_mgrm_alaune_image', true );
		$img_elem	= mgrm_alaune_get_image( $post->ID, $img_id, 'medium', false, array( 'style' => 'display:block;margin-top:10px;' ) );
		$img_elem	= str_replace( 'width="1"', 'width="520"', $img_elem );
		$img_elem	= str_replace( 'height="1"', 'height="auto"', $img_elem );
		
		?>
		<table class="form-table">
			<tr>
				<th valign="top"><label><?php echo $this->video_label; ?></label></th>
				<td>
					<input type="text" class="large-text" name="mgrm_alaune_video" value="<?php echo $vid_url; ?>">
					<small><?php echo $this->video_info; ?></small>
				</td>
			</tr>
			<tr>
				<th valign="top"><label><?php echo $this->image_label; ?></label></th>
				<td>
					<input type="button" class="button media-browser" value="<?php echo $this->image_select; ?>" /> <input type="button" class="button media-remove" value="<?php echo $this->image_del; ?>" />
					<input id="mgrm_alaune_image" type="hidden" value="<?php echo $img_id; ?>" name="mgrm_alaune_image"><br>
					<?php echo $img_elem; ?>
				</td>
			</tr>
		</table>
		<?php
	}
	
	
	// Modifier l'ordre pour afficher les champs en dessous du titre
	function move_box()
	{
		# Get the globals:
		global $post, $wp_meta_boxes;
		
		# Output the "advanced" meta boxes:
		do_meta_boxes( get_current_screen(), 'mgrm_alaune', $post );
		
		# Remove the initial "advanced" meta boxes:
		unset($wp_meta_boxes['post']['mgrm_alaune']);
	}
	
	
	// Enregistrer les données
	function save_meta( $post_id )
	{
		if ( isset( $_POST['mgrm_alaune_video'] ) )
		{
			update_post_meta( $post_id, '_mgrm_alaune_video', strip_tags( $_POST['mgrm_alaune_video'] ) );
		}
		if ( isset( $_POST['mgrm_alaune_image'] ) )
		{
			update_post_meta( $post_id, '_mgrm_alaune_image', $_POST['mgrm_alaune_image'] );
		}
	}
	
	
	// Ajouter la taille des images
	function thumbnail_size()
	{
		add_image_size( 'post-thumbnail', $this->imgmaxw, $this->imgmaxh, true );
	}
	
	
	// Ajouter des css pour que le bloc ne soit pas trop collé au titre
	function add_css()
	{
		echo "<style>
		#mgrm_alaune-sortables {
			margin-top: 30px;
		}
		</style>";
	}
	
	
	// Ajoute le js et css
	function admin_js_css( $current_screen )
	{
		if ( $current_screen == 'post.php' || $current_screen == 'post-new.php' )
		{
			$path	= get_template_directory_uri();
			
			//wp_enqueue_style( 'mgrm_'.$this->slug, $path.'css/custom.css' );
			
			wp_enqueue_script('jquery');
			wp_enqueue_media();
			wp_enqueue_script( 'mgrm_'.$this->slug, $path.'/custom/'.$this->slug.'/'.$this->slug.'.js', array('jquery'), "", false );
		}
	}
}


// Renvoie la video à la une
function mgrm_alaune_get_video( $pid='' )
{
	global $post;
	
	if ( empty( $pid ) )
		$pid	= $post->ID;
	
	$vid_url	= get_post_meta( $pid, '_mgrm_alaune_video', true );
	
	if ( empty( $vid_url ) )
	{
		return;
	}
	
	$yid	= $vid_url;
	$vpos	= strpos( $yid, "v=" );
	$esppos	= strpos( $yid, "&", $vpos );
	$yid	= !empty($esppos) ? substr( $yid, $vpos+2, $esppos-$vpos-2 ) : substr( $yid, $vpos+2 );
	
	$vid_obj	= '<div class="video-wrapper"><iframe width="640" height="360" src="//www.youtube.com/embed/'.$yid.'?rel=0&amp;showinfo=0" frameborder="0" allowfullscreen></iframe></div>';
	return $vid_obj;
}
	
	
// Renvoie l'image à la une
function mgrm_alaune_get_image( $pid='', $img_id='', $size='post-thumbnail', $icon=false, $attr=''  )
{
	global $blog_national_id, $post;
	
	if ( empty( $pid ) )
		$pid	= $post->ID;
	
	if ( empty( $img_id ) )
	{
		$img_id	= get_post_meta( $pid, '_mgrm_alaune_image', true );
	}
	
	if ( empty( $img_id ) )
		return;
	
	$img_id		= str_replace( 'nat-', '', $img_id );
	//$is_national	= strpos( $img_id, 'nat-' ) !== false ? true : false;
	$img_elem		= "";
	//if ( $is_national )
	//{
	//	switch_to_blog( $blog_national_id );
	//	$nat_img_id		= str_replace( 'nat-', '', $img_id );
	//	$img_elem	= wp_get_attachment_image( $nat_img_id, $size, $icon, $attr );
	//	restore_current_blog();
	//	
	//}else{
		$img_elem	= wp_get_attachment_image( $img_id, $size, $icon, $attr );
	//}
	
	return $img_elem;
}


// Vérifie si il y a une image à la une pour le post actif
function mgrm_alaune_has_image( $pid='' )
{
	global $post;
	
	if ( empty( $pid ) )
		$pid	= $post->ID;

	$img_id		= get_post_meta( $pid, '_mgrm_alaune_image', true );
	
	if ( empty( $img_id ) )
	{
		return false;
	}
	return true;
}