<?php

$mgrm_bloc_top		= new mgrm_bloc_top;

class mgrm_bloc_top {
	
	var $slug	= 'bloc_top';
	
	var $trad	= '';
	
	var $cur_lng	= '';
	
	var $nbr_col	= 3;
	
	function __construct()
	{
		global $mgrm_lng;
		
		$this->cur_lng	= $mgrm_lng->cur_lng;
		
		
		// --- Traductions
		
		$this->trad	= new StdClass();
		$this->trad->front_title		= 'A la une';
		
		$this->trad->admin_title		= 'Blocs promo';
		
		$this->trad->btn_lnkblank		= "Ouvrir dans une nouvelle fenêtre/onglet";
		$this->trad->btn_img			= "Sélectionner une photo";
		
		
		// --- Actions
		
		// Admin
		add_action( 'admin_enqueue_scripts', array( $this, 'add_admin_js_css' ) );
		add_action( 'admin_menu', array( $this, 'add_admin_menu' ) );
		
		// Front
		add_action( 'wp_enqueue_scripts', array( $this, 'add_front_js_css' ) );
		add_action( 'mgrm_bloc_info', array( $this, 'front_display' ) );
	}
	
	
	function add_admin_js_css( $current_screen )
	{
		global $mgrm_infos;
		//print $current_screen;
		if ( $current_screen == sanitize_title( !empty( $mgrm_infos->site_title ) ? $mgrm_infos->site_title : get_bloginfo( 'sitename' ) ).'_page_'.$this->slug."_admin_page" )
		{
			$path = get_stylesheet_directory_uri().'/custom/'.$this->slug;
			
			wp_enqueue_style( 'mgrm_'.$this->slug, $path.'/css/admin.css', array(), null );
			
			wp_enqueue_script('jquery');
			
			wp_enqueue_media();
			
			wp_enqueue_script( 'mgrm_'.$this->slug, $path.'/js/admin.js', array('jquery'), null, false );
		}
	}
	
	
	function add_admin_menu()
	{
		global $mgrm_infos;
		
		add_submenu_page( $mgrm_infos->slug, $this->trad->admin_title, $this->trad->admin_title, 'delete_others_posts', $this->slug."_admin_page", array( $this, "add_admin_page" ) );
	}
	
	
	function add_admin_page()
	{
		if ( isset( $_POST['action'] ) && $_POST['action'] == 'update' )
		{			
			$message = $this->update_changes();
		}
		
		//delete_option( 'mgrm_'.$this->slug );
		
		$data	= get_option( 'mgrm_'.$this->slug );
	    $data	= json_decode( $data );
	    /*
	    print "<pre>";
	    print_r( $data );
	    print "</pre>";
	    */
		$data_count	= count( (array)$data );
		
		//print $data_count;
		
		$next_class	= $data_count == 0 ? ' disabled' : '';
		
		
		?>
		<div class="wrap">
			<h2>
				<?php echo $this->trad->admin_title; ?>
			</h2>
			<p>Pour un rendu impeccable utilisez des images de même taille.</p>
			<form action="" method="post">
				<input type="hidden" value="update" name="action">
				
				<table class="widefat">
					<thead>
						<tr>
							<?php for ( $i=1; $i<=$this->nbr_col; $i++ ) : ?>
							<th align="left" width="<?php echo 100/$this->nbr_col; ?>%"><h3>Bloc <?php echo $i; ?></h3></th>
							<?php endfor; ?>
						</tr>
					</thead>
					<tbody>
						
						<?php
						//for ( $i=0; $i<$data_count; $i++ ) : 
							
							//$alternate_class 	= !is_int( $i/2 ) ? ' class="alternate"' : '';
							//$next_class			= $i==$data_count-1 ? ' disabled' : '';
							
							?>
							<tr<?php //echo $alternate_class; ?>>
							<?php
							for ( $j=0; $j<$this->nbr_col; $j++ ) : 
							
								$titre		= stripslashes( isset( $data->{$j}->titre ) ? $data->{$j}->titre : '' );
								$sous_titre	= stripslashes( isset( $data->{$j}->sous_titre ) ? $data->{$j}->sous_titre : '' );
								$lnk		= stripslashes( isset( $data->{$j}->lnk ) ? $data->{$j}->lnk : '' );
								$lnkblank	= isset( $data->{$j}->lnkblank ) && $data->{$j}->lnkblank == 1 ? 1 : 0;
								$img_id		= isset( $data->{$j}->img ) ? $data->{$j}->img : '';
								$img		= !empty( $img_id ) ? '<br><br>'.wp_get_attachment_image( $img_id, 'medium', false, array( 'id' => 'img_'.$img_id ) ) : '';
							
								?>
							
							<td>
								<p>
									<input type="text" class="large-text" name="titre_<?php echo $j; ?>_<?php echo $this->cur_lng; ?>" placeholder="Titre" value="<?php echo $titre; ?>" />
								</p>
								<p>
									<input type="text" class="large-text" name="sous_titre_<?php echo $j; ?>_<?php echo $this->cur_lng; ?>" placeholder="Sous-titre" value="<?php echo $sous_titre; ?>" />
								</p>
								<p>
									<input type="text" class="large-text" name="lnk_<?php echo $j; ?>_<?php echo $this->cur_lng; ?>" placeholder="http://..." value="<?php echo $lnk; ?>"><br>
									<label>
										<input type="checkbox" name="lnkblank_<?php echo $j; ?>_<?php echo $this->cur_lng; ?>" value="1"<?php echo checked( 1, $lnkblank, 1 ); ?>>
										<?php echo $this->trad->btn_lnkblank; ?>
									</label>
								</p>
								<p>
									<input type="button" class="button media-browser" value="<?php echo $this->trad->btn_img; ?>" />
									<input type="hidden" name="img_<?php echo $j; ?>_<?php echo $this->cur_lng; ?>" value="<?php echo $img_id; ?>">
									<?php echo $img; ?>
								</p>
							</td>
							<?php endfor; ?>
						</tr>
						<?php //endfor; ?>
						
						
					</tbody>
				</table>
				
				<p class="submit"><input id="submit" class="button button-primary" type="submit" value="<?php echo __('Save Changes'); ?>" name="submit"></p>
			</form>
		</div>
		<?php
	}
	
	
	function update_changes()
	{
		/*
		print "<pre>";
		print_r( $_POST );
		print "</pre>";
		*/
		
		$data	= new StdClass();
		
		$post		= $_POST;
		$post_count	= count( $post );
		$k			= 0;
		
		// Ligne par ligne
		//for ( $i=0; $i<$post_count; $i++ )
		//{
			// Colonne par colonne
			for ( $j=0; $j<$this->nbr_col; $j++ )
			{
				// Vérifier si la catégorie existe et qu'elle n'est pas vide
				if ( isset( $post[ 'titre_'.$j.'_'.$this->cur_lng ] ) && !empty( $post[ 'titre_'.$j.'_'.$this->cur_lng ] ) )
				{
					$item	= new StdClass();
					$item->titre		= $post[ 'titre_'.$j.'_'.$this->cur_lng ];
					$item->sous_titre	= $post[ 'sous_titre_'.$j.'_'.$this->cur_lng ];
					$item->lnk			= $post[ 'lnk_'.$j.'_'.$this->cur_lng ];
					$item->lnkblank		= isset( $post[ 'lnkblank_'.$j.'_'.$this->cur_lng ] ) ? $post[ 'lnkblank_'.$j.'_'.$this->cur_lng ] : 0;
					$item->img			= $post[ 'img_'.$j.'_'.$this->cur_lng ];
					
					$data->{$j}	= $item;
				}
				
				//if ( isset( $data->{$k} ) && $j == $this->nbr_col )
				//{
				//	$k++;
				//}
			}
		//}
		/*
		print "<pre>";
		print_r( $data );
		print "</pre>";
		*/
		
	    $data	= json_encode( $data );
		$data	= update_option( 'mgrm_'.$this->slug, $data );
	}
	
	
	
	// Ajouter les css sur la partie publique
	function add_front_js_css()
	{
		$path = get_stylesheet_directory_uri().'/custom/'.$this->slug;
		
		wp_enqueue_style( 'mgrm_'.$this->slug, $path.'/css/front.css', array(), null );
	}
	
	
	function front_display( $bloc_nbr )
	{
		
		$data	= get_option( 'mgrm_'.$this->slug );
	    $data	= json_decode( $data );
	    
		$data_count	= count( (array)$data );
		
		//print "<pre>";
		//print_r( $data );
		//print "</pre>";
		
		$bloc_nbr = 0;
		
		//print count( (array)$data->{'0'} );
		
		if ( !empty( $data ) )
		{
			?>
			<div id="<?php echo $this->slug; ?>" class="container">
				<div class="row">
			<?php
			foreach( $data as $bloc )
			{
				// Ne pas afficher si la première rangée n'est pas complpète.
				if ( isset( $bloc ) && !empty( $bloc ) )
				{
					if ( isset( $bloc->titre ) && !empty( $bloc->titre ) )
					{
						$titre		= $bloc->titre;
						$sous_titre	= $bloc->sous_titre;
						$lnk_blank	= !empty( $bloc->lnkblank ) ? ' target="_blank"' : '';
						$lnk_open	= !empty( $bloc->lnk ) ? '<a href="'.$bloc->lnk.'"'.$lnk_blank.'>' : '';
						$lnk_close	= !empty( $lnk_open ) ? '</a>' : '';
						$img_id		= isset( $bloc->img ) ? $bloc->img : '';
						$img		= !empty( $img_id ) ? wp_get_attachment_image( $img_id, 'large', false, array( 'id' => 'img_'.$img_id ) ) : '';
						
				?>
					<div id="<?php echo $this->slug.'-'.$bloc_nbr; ?>" class="<?php echo $this->slug; ?> col-sm-4">
						<?php echo $lnk_open; ?>
						<p><span class="content-titre"><?php echo $titre; ?></span>
						<span class="content-sous-titre"><?php echo $sous_titre; ?></span></p>
						<?php echo $img; ?>
						<?php echo $lnk_close; ?>
					</div>
				<?php
						$bloc_nbr++;
					}
				}
			}
			?>
				</div></div>
			<?php
		}
	}
}