<?php

$mgrm_fond		= new mgrm_fond;

class mgrm_fond {
	
	var $slug	= 'fond';
	
	var $trad	= '';
	
	var $cur_lng	= '';
	
	var $nbr_col	= 3;
	
	function __construct()
	{
		global $mgrm_lng;
		
		$this->cur_lng	= $mgrm_lng->cur_lng;
		
		
		// --- Traductions
		
		$this->trad	= new StdClass();
		
		$this->trad->admin_title		= 'Fonds d\'écran';
		
		$this->trad->btn_lnkblank		= "Ouvrir dans une nouvelle fenêtre/onglet";
		$this->trad->btn_img			= "Sélectionner une photo";
		
		
		// --- Actions
		
		// Admin
		add_action( 'admin_enqueue_scripts', array( $this, 'add_admin_js_css' ) );
		add_action( 'admin_menu', array( $this, 'add_admin_menu' ) );
		
		// Front
		add_action( 'wp_enqueue_scripts', array( $this, 'add_front_js_css' ) );
		add_action( 'wp_footer', array( $this, 'front_display' ) );
	}
	
	
	function add_admin_js_css( $current_screen )
	{
		global $mgrm_infos;
		//print $current_screen;
		if ( $current_screen == sanitize_title( !empty( $mgrm_infos->site_title ) ? $mgrm_infos->site_title : get_bloginfo( 'sitename' ) ).'_page_'.$this->slug."_admin_page" )
		{
			$path = get_stylesheet_directory_uri().'/custom/'.$this->slug;
			
			wp_enqueue_style( 'mgrm_'.$this->slug, $path.'/css/admin.css', array(), null );
			
			wp_enqueue_script('jquery');
			
			wp_enqueue_media();
			
			wp_enqueue_script( 'mgrm_'.$this->slug, $path.'/js/admin.js', array('jquery'), null, false );
		}
	}
	
	
	function add_admin_menu()
	{
		global $mgrm_infos;
		
		add_submenu_page( $mgrm_infos->slug, $this->trad->admin_title, $this->trad->admin_title, 'delete_others_posts', $this->slug."_admin_page", array( $this, "add_admin_page" ) );
	}
	
	
	function add_admin_page()
	{
		if ( isset( $_POST['action'] ) && $_POST['action'] == 'update' )
		{			
			$message = $this->update_changes();
		}
		
		//delete_option( 'mgrm_'.$this->slug );
		
		$data	= get_option( 'mgrm_'.$this->slug );
	    $data	= json_decode( $data );
	    /*
	    print "<pre>";
	    print_r( $data );
	    print "</pre>";
	    */
		$data_count	= count( (array)$data );
		//print $data_count;
		
		$next_class	= $data_count == 0 ? ' disabled' : '';
		
		
		?>
		<div class="wrap">
			<h2>
				<?php echo $this->trad->admin_title; ?>
			</h2>
			<form action="" method="post">
				<input type="hidden" value="update" name="action">
				
				<h3>Pages</h3>
				<table class="widefat">
					<thead>
						<td>Titre de la page</td>
						<td style="width:120px">Image de fond</td>
						<td></td>
					</thead>
					<tbody>
						<?php
						
						$pages	= get_pages();
						$i		= 0;
						
						foreach( $pages	as $page )
						{
							$pid	= $page->ID;
							$ptitle = $page->post_title;
							
							$img_id	= isset( $data->pages->{$pid} ) ? $data->pages->{$pid} : 0;
							$img	= !empty( $img_id ) ? wp_get_attachment_image( $img_id, 'thumbnail', false, array( 'style' => 'width:100px;height:auto' ) ) : '';
							
							$alternate	= is_int( $i/2 ) ? ' class="alternate"' : '';
							
							?>
							<tr<?php echo $alternate; ?>>
								<th><?php echo $ptitle; ?><input type="hidden" name="page_id_<?php echo $i; ?>_<?php echo $this->cur_lng; ?>" value="<?php echo $pid; ?>"></th>
								<td><?php echo $img; ?></td>
								<td style="vertical-align:middle">
									<input type="button" class="button media-browser" value="<?php echo $this->trad->btn_img; ?>" />
									<input type="hidden" name="page_img_<?php echo $i; ?>_<?php echo $this->cur_lng; ?>" value="<?php echo $img_id; ?>">
								</td>
							</tr>
							<?php
								
							$i++;
						}
						
						?>
					</tbody>
				</table>
				
				<h3>Categories</h3>
				<table class="widefat">
					<thead>
						<td>Titre de la catégorie</td>
						<td style="width:120px">Image de fond</td>
						<td></td>
					</thead>
					<tbody>
						<?php
						
						$cats	= get_categories();
						$i		= 0;
						
						foreach( $cats	as $cat )
						{
							$cid	= $cat->term_id;
							$ctitle = $cat->name;
							
							$img_id	= isset( $data->categories->{$cid} ) ? $data->categories->{$cid} : 0;
							$img	= !empty( $img_id ) ? wp_get_attachment_image( $img_id, 'thumbnail', false, array( 'style' => 'width:100px;height:auto' ) ) : '';
							
							$alternate	= is_int( $i/2 ) ? ' class="alternate"' : '';
							
							?>
							<tr<?php echo $alternate; ?>>
								<th><?php echo $ctitle; ?><input type="hidden" name="cat_id_<?php echo $i; ?>_<?php echo $this->cur_lng; ?>" value="<?php echo $cid; ?>"></th>
								<td><?php echo $img; ?></td>
								<td style="vertical-align:middle">
									<input type="button" class="button media-browser" value="<?php echo $this->trad->btn_img; ?>" />
									<input type="hidden" name="cat_img_<?php echo $i; ?>_<?php echo $this->cur_lng; ?>" value="<?php echo $img_id; ?>">
								</td>
							</tr>
							<?php
								
							$i++;
						}
						
						?>
					</tbody>
				</table>
				
				<p class="submit"><input id="submit" class="button button-primary" type="submit" value="<?php echo __('Save Changes'); ?>" name="submit"></p>
			</form>
		</div>
		<?php
	}
	
	
	function update_changes()
	{
		/*
		print "<pre>";
		print_r( $_POST );
		print "</pre>";
		*/
		
		$data	= new StdClass();
		
		$post		= $_POST;
		$post_count	= count( $post );
		$k			= 0;
		
		
		for ( $i=0; $i<$post_count; $i++ )
		{
			
			// Pages
			$pid	= isset( $post['page_id_'.$i.'_'.$this->cur_lng] ) ? $post['page_id_'.$i.'_'.$this->cur_lng] : 0;
			$imgid	= isset( $post['page_img_'.$i.'_'.$this->cur_lng] ) ? $post['page_img_'.$i.'_'.$this->cur_lng] : 0;
			
			if ( !empty( $pid ) && !empty( $imgid ) )
			{
				$data->pages->{$pid} = $imgid;
			}
			
			// Categories
			$cid	= isset( $post['cat_id_'.$i.'_'.$this->cur_lng] ) ? $post['cat_id_'.$i.'_'.$this->cur_lng] : 0;
			$cimgid	= isset( $post['cat_img_'.$i.'_'.$this->cur_lng] ) ? $post['cat_img_'.$i.'_'.$this->cur_lng] : 0;
			
			if ( !empty( $cid ) && !empty( $cimgid ) )
			{
				$data->categories->{$cid} = $cimgid;
			}
		}
		/*
		print "<pre>";
		print_r( $data );
		print "</pre>";
		*/
		
	    $data	= json_encode( $data );
		$data	= update_option( 'mgrm_'.$this->slug, $data );
	}
	
	
	
	// Ajouter les css sur la partie publique
	function add_front_js_css()
	{
		$path = get_stylesheet_directory_uri().'/custom/'.$this->slug;
		
		wp_enqueue_script( 'mgrm_'.$this->slug.'_supersized', $path.'/js/supersized.core.3.2.1.min.js', array(), null );
		//wp_enqueue_script( 'mgrm_'.$this->slug, $path.'/js/front.js', array(), null );
		
		wp_enqueue_style( 'mgrm_'.$this->slug.'_supersized', $path.'/css/supersized.core.css', array(), null );
		//wp_enqueue_style( 'mgrm_'.$this->slug, $path.'/css/front.css', array(), null );
	}
	
	
	function front_display( $bloc_nbr )
	{
		global $post;
		
		$data	= get_option( 'mgrm_'.$this->slug );
	    $data	= json_decode( $data );
	    
		$data_count	= count( (array)$data );
		
		//print "<pre>";
		//print_r( $data );
		//print "</pre>";
		
		//print count( (array)$data->{'0'} );
		
		if ( !empty( $data ) )
		{
			$page_id	= get_the_id();//get_query_var( 'page_id' );
			$cat_id		= get_query_var( 'cat' );
			$img_id		= 0;
			
			
			if ( !empty( $page_id ) && !is_category() )
			{
				$img_id	= isset( $data->pages->{$page_id} ) ? $data->pages->{$page_id} : 0;
			}else 
			if ( is_category() || ( empty( $page_id ) && !empty( $cat_id ) ) )
			{
				$img_id	= isset( $data->categories->{$cat_id} ) ? $data->categories->{$cat_id} : 0;
			}else 
			if ( empty( $page_id ) && empty( $cat_id ) )
			{
				$pid	= $post->ID;
				$cat_ids	= wp_get_post_categories( $pid );
				
				$img_id	= isset( $data->categories->{$cat_ids[0]} ) ? $data->categories->{$cat_ids[0]} : 0;
			}
				
			if ( !empty( $img_id ) )
			{
				$bg_img	= wp_get_attachment_image_src( $img_id, 'full', false, array( 'id' => 'bg-img' ) );
				$bg_img	= $bg_img[0];
			
				?>
				<script type="text/javascript">
				jQuery(document).ready(function($) {
					$.supersized({
						slides  :  	[ {image : '<?php echo $bg_img; ?>'} ]
					});
				});
				</script>
				<?php
			}
			
			/*
			?>
			<div id="<?php echo $this->slug; ?>"><div class="container"><div class="row"><div class="row-height">
			<?php
			foreach( $data as $bloc )
			{
				// Ne pas afficher si la première rangée n'est pas complpète.
				if ( isset( $bloc ) && !empty( $bloc ) )
				{
					$page		= $bloc->page;
					$cat		= $bloc->cat;
					$btn_txt	= $bloc->btn_txt;
					
					if ( !empty( $page ) )
					{
						$post	= get_post( $page );
						
						$titre	= $post->post_title;
						$link	= get_post_permalink( $post->ID );
						
					}else if ( !empty( $cat ) )
					{
						$cat	= get_category( $cat );
						
						$titre	= $cat->name;
						$link	= get_category_link( $cat );
					}
					
					$img		= wp_get_attachment_image( $bloc->img, 'medium' );
					$text		= $bloc->texte;
					
					?>
					<div id="<?php echo $this->slug.'-'.$bloc_nbr; ?>" class="<?php echo $this->slug; ?> col-sm-4 col-height">
						<p class="post-title"><?php echo $titre; ?></p>
						<div class="post-img"><?php echo !empty( $img ) ? $img : ''; ?></div>
						<div class="post-content">
							<?php echo $text; ?>
							<p class="link"><a class="btn btn-default" href="<?php echo $link; ?>"><?php echo $btn_txt; ?></a></p>
						</div>
					</div>
					<?php
					
					$bloc_nbr++;
				}
			}
			?>
			</div></div></div></div>
			<?php
			*/
		}
	}
}