<?php

$mgrm_forms	= new mgrm_forms;

class mgrm_forms {

	var $slug		= 'mgrm-forms';
	
	var $bid		= 0;
	
	var $cur_lng	= '';
	
	var $trad		= '';
	
	var $form_shortcode	= "mgrm-forms-";
	
	var $data		= "";
	
	
	function __construct()
	{
		global $mgrm_lng;
		
		
		$this->bid	= get_current_blog_id();
		
		
		// Langues
		$this->cur_lng	= $mgrm_lng->cur_lng;
		
		
		// --- Traductions
		
		$this->trad	= new StdClass();
		$this->trad->page_title				= "Formulaires";
		
		$this->trad->admin_menu_title		= "Formulaires";
		$this->trad->admin_menu_subtitle	= "Tous les formulaires";
		$this->trad->admin_menu_add			= "Ajouter";
		
		$this->trad->admin_page_noforms		= "Désolé, il n'y a pas de formulaires. Vous pouvez en créer un.";
		$this->trad->admin_page_addform		= "Ajouter un nouveau formulaire";
		
		$this->trad->form_confirm		= '<p class="text-success">Votre demande a bien été envoyée, nous vous contacterons dans les plus brefs délais.</p>';
		$this->trad->form_error			= '<p class="text-danger">Veuillez remplir correctement les champs mis en évidence, merci.</p>';
		$this->trad->form_error_send	= '<p class="text-warning">Une erreur est survenue lors de l\'envoi. Veuillez réessayer s\'il vous plait, merci.</p>';
		$this->trad->form_send			= 'Envoyer';
		$this->trad->form_captcha		= 'Code de sécurité';
		$this->trad->form_captcha_ph	= 'Copiez le code ci-dessous';
		$this->trad->form_select_first	= '- Choisissez -';
		
		$this->trad->file_error_1		= 'Il y a eu un problème lors du transfert du fichier.';
		$this->trad->file_error_2		= 'Le fichier n\'a pas pu être copié.';
		$this->trad->file_error_3		= 'Le type de fichier n\'est pas autorisé.';
		$this->trad->file_error_4		= 'L\'image est corrompue.';
		$this->trad->file_error_5		= 'Le fichier est trop volumineux.';
		$this->trad->file_error_6		= 'Merci de ne pas vouloir essayer de changer la configuration du serveur.';
		$this->trad->file_error_7		= 'Veuillez sélectionner à nouveau votre fichier.';
		
		if ( $this->cur_lng == 'nl' )
		{
			$this->trad->page_title				= "Formulieren";
			
			$this->trad->admin_menu_title		= "Formulieren";
			$this->trad->admin_menu_subtitle	= "Alle formulieren";
			$this->trad->admin_menu_add			= "Nieuw formulier";
		
			$this->trad->form_confirm		= '<p class="text-success">Uw vraag werd wel degelijk verzonden, wij zo snel mogelijk zullen u contact opnemen.</p>';
			$this->trad->form_error			= '<p class="text-danger">Gelieve juist de velden te vullen die de aandacht op worden gevestigd op, bedankt.</p>';
			$this->trad->form_error_send	= '<p class="text-warning">Een fout is bij de zending voorgekomen. Gelieve opnieuw te proberen als hij u, bedankt bevalt.</p>';
			$this->trad->form_send			= 'Verzenden';
			$this->trad->form_captcha		= 'Veiligheidscode';
			$this->trad->form_captcha_ph	= 'Kopiëer hier de code';
			$this->trad->form_select_first	= '- Kies -';
		}
		
		if ( $this->cur_lng == 'en' )
		{
			$this->trad->page_title				= "Forms";
			
			$this->trad->admin_menu_title		= "Forms";
			$this->trad->admin_menu_subtitle	= "All forms";
			$this->trad->admin_menu_add			= "Add";
		
			$this->trad->form_confirm		= '<p class="text-success">We have received your message, we will contact you as soon as possible.</p>';
			$this->trad->form_error			= '<p class="text-danger">Please fill all the highlighted fields, thank you.</p>';
			$this->trad->form_error_send	= '<p class="text-warning">There was a problem while sending your message. Could you please try again ? Thank you.</p>';
			$this->trad->form_send			= 'Send';
			$this->trad->form_captcha		= 'Security code';
			$this->trad->form_captcha_ph	= 'Please copy the code below';
			$this->trad->form_select_first	= '- Choose -';
		}
		
		
		// --- Actions
		
		
		// Admin
		//add_action( 'admin_enqueue_scripts', array( $this, 'admin_page_js_css' ) );
		//add_action( 'admin_menu', array( $this, 'add_admin_menu' ) );
		
		
		// Formulaire de contact pour tous
		add_shortcode( $this->form_shortcode.'contact', array( $this, 'display_form_contact' ) );
		add_shortcode( $this->form_shortcode.'devis', array( $this, 'display_form_devis' ) );
	}
	
	
	// Formulaire de contact pour tout le monde
	function display_form_contact()
	{
		global $mgrm_infos, $_SESSION, $_POST;
		
		$email_mag	= $mgrm_infos->get_info( 'email' );
		
		if ( empty( $email_mag ) )
			return;
		
		// Traductions
		$trad	= new StdClass();
		$trad->email_sujet		= "Contact";
		$trad->title			= "Contactez nous";
		$trad->champ_nom		= "Nom";
		$trad->champ_prenom		= "Prénom";
		$trad->champ_email		= "Email";
		$trad->champ_tel		= "Téléphone";
		$trad->champ_message	= "Renseignement(s)";
		
		if ( $this->cur_lng == 'nl' )
		{
			$trad->email_sujet		= "Contact";
			$trad->title			= "Contacteer ons";
			$trad->champ_nom		= "Naam";
			$trad->champ_prenom		= "Voornaam";
			$trad->champ_email		= "E-mail";
			$trad->champ_tel		= "Telefoon";
			$trad->champ_message	= "Bericht";
			
		}else if ( $this->cur_lng == 'en' )
		{
			$trad->email_sujet		= "Contact";
			$trad->title			= "Contact us";
			$trad->champ_nom		= "Last name";
			$trad->champ_prenom		= "First name";
			$trad->champ_email		= "Email";
			$trad->champ_tel		= "Phone";
			$trad->champ_message	= "Message";
		}
		
		// Champs du formulaire
		$fields	= array(
			array(
				'type'	=> 'text',
				'name'	=> 'nom',
				'label'	=> $trad->champ_nom,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'prenom',
				'label'	=> $trad->champ_prenom,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'email',
				'label'	=> $trad->champ_email,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'tel',
				'label'	=> $trad->champ_tel,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'textarea',
				'name'	=> 'message',
				'label'	=> $trad->champ_message,
				'class'	=> '',
				'required'	=> 1,
				'rows'	=> 5
			)
		);
		
		$form	= $this->generate_form( $fields, $trad, $email_mag );
		
		return $form;
	}
	
	
	// Formulaire de contact pour tout le monde
	function display_form_devis()
	{
		global $mgrm_infos, $_SESSION, $_POST;
		
		$email_mag	= $mgrm_infos->get_info( 'email' );
		
		if ( empty( $email_mag ) )
			return;
		
		// Traductions
		$trad	= new StdClass();
		$trad->email_sujet		= "Devis";
		$trad->title			= "";
		$trad->champ_nom		= "Nom";
		$trad->champ_prenom		= "Prénom";
		$trad->champ_rue_num	= "Rue & numéro";
		$trad->champ_cp			= "Code postal";
		$trad->champ_ville		= "Ville";
		$trad->champ_email		= "Email";
		$trad->champ_tel		= "Téléphone";
		$trad->champ_date		= "Date souhaitée du début des travaux";
		$trad->champ_message	= "Décrivez votre projet avec le maximum de detail";
		
		$trad->champ_projet		= "Projet";
		$trad->champ_projet_values	= array( 'Nouvelle construction', 'Rénovation', 'Bâtiment professionnel', 'Projet immobilier' );
		
		if ( $this->cur_lng == 'nl' )
		{
			$trad->email_sujet		= "Contact";
			$trad->title			= "Contacteer ons";
			$trad->champ_nom		= "Naam";
			$trad->champ_prenom		= "Voornaam";
			$trad->champ_email		= "E-mail";
			$trad->champ_tel		= "Telefoon";
			$trad->champ_message	= "Bericht";
			
		}else if ( $this->cur_lng == 'en' )
		{
			$trad->email_sujet		= "Contact";
			$trad->title			= "Contact us";
			$trad->champ_nom		= "Last name";
			$trad->champ_prenom		= "First name";
			$trad->champ_email		= "Email";
			$trad->champ_tel		= "Phone";
			$trad->champ_message	= "Message";
		}
		
		// Champs du formulaire
		$fields	= array(
			array(
				'type'	=> 'text',
				'name'	=> 'nom',
				'label'	=> $trad->champ_nom,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'prenom',
				'label'	=> $trad->champ_prenom,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'rue_num',
				'label'	=> $trad->champ_rue_num,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'cp',
				'label'	=> $trad->champ_cp,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'ville',
				'label'	=> $trad->champ_ville,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'tel',
				'label'	=> $trad->champ_tel,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'text',
				'name'	=> 'email',
				'label'	=> $trad->champ_email,
				'class'	=> '',
				'required'	=> 1
			),
			array(
				'type'	=> 'select',
				'name'	=> 'projet',
				'label'	=> $trad->champ_projet,
				'class'	=> '',
				'required'	=> 1,
				'values'	=> $trad->champ_projet_values
			),
			array(
				'type'	=> 'text',
				'name'	=> 'date',
				'label'	=> $trad->champ_date,
				'class'	=> '',
				'required'	=> 0
			),
			array(
				'type'	=> 'textarea',
				'name'	=> 'message',
				'label'	=> $trad->champ_message,
				'class'	=> '',
				'required'	=> 1,
				'rows'	=> 5
			)
		);
		
		$form	= $this->generate_form( $fields, $trad, $email_mag );
		
		return $form;
	}
	
	
	// Ajouter le menu dans l'admin
	function add_admin_menu ()
	{	
		add_menu_page( $this->trad->admin_menu_title, $this->trad->admin_menu_title, 'delete_others_posts', $this->slug, array( $this, "add_admin_page" ), 'dashicons-forms', 26 );
		add_submenu_page( $this->slug, $this->trad->admin_menu_subtitle, $this->trad->admin_menu_subtitle, 'delete_others_posts', $this->slug, array( $this, "add_admin_page" ) );
		add_submenu_page( $this->slug, $this->trad->admin_menu_add, $this->trad->admin_menu_add, 'delete_others_posts', $this->slug.'-add', array( $this, "add_admin_page_add" ) );
	}
	
	
	// Admin page js, css
	function admin_page_js_css()
	{
		$path	= get_template_directory_uri();
		
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'jquery-ui-draggable' );
		wp_enqueue_script( 'jquery-ui-droppable' );
	}
	
	
	// Admin page
	function add_admin_page()
	{
		$content = "";
		
		// Si il n'y a rien
		if ( empty( $this->data ) )
		{
			$content	= '<p>'.$this->trad->admin_page_noforms.'</p>';
			
		}else{
			// Si il y a quelque chose, faire la liste.
			//<form action="" method="post">
			//	<input type="hidden" value="update" name="action">
			//</form>
		}
		
		?>
		<div class="wrap">
			<h2>
				<?php echo $this->trad->page_title; ?>
				<a href="admin.php?page=<?php echo $this->slug; ?>-add" class="add-new-h2"><?php echo $this->trad->admin_menu_add; ?></a>
			</h2>
			<?php echo $content; ?>
		</div>
		<?php
	}
	
	
	// Admin page to add forms
	function add_admin_page_add()
	{
		$content = "";
		
		// Si il n'y a rien
		if ( empty( $this->data ) )
		{
			$content	= '<p>'.$this->trad->admin_page_noforms.'</p>';
			
		}else{
			// Si il y a quelque chose, faire la liste.
			//<form action="" method="post">
			//	<input type="hidden" value="update" name="action">
			//</form>
		}
		
		?>
		<div class="wrap">
			<h2><?php echo $this->trad->admin_page_addform; ?></h2>
			<form action="admin.php?page=<?php echo $this->slug; ?>-add" method="post">
				<div id="poststuff">
					<div id="post-body" class="metabox-holder columns-2">
						<div id="post-body-content" style="position: relative;">
						
							<!-- Titre -->
							<div id="titlediv">
								<div id="titlewrap">
									<label id="title-prompt-text" class="" for="title">Saisissez votre titre ici</label>
									<input id="title" type="text" autocomplete="off" spellcheck="true" value="" size="30" name="form_title">
								</div>
								<div class="inside">
									<div id="edit-slug-box" class="hide-if-no-js"></div>
								</div>
							</div>
							
							<!-- Champs de formulaire -->
							<div class="meta-box">
								<div class="postbox ">
									<h3 class="hndle"><span>Champs de formulaire</span></h3>
									<div class="inside">
										<div class="fields-empty">Glissez ici les différents types de champs (depuis la colonne de droite) que vous désirez ajouter</div>
									</div>
								</div>
							</div>
							
							<!-- Configuration -->
							<div class="meta-box">
								<div class="postbox ">
									<h3 class="hndle"><span>Configuration</span></h3>
									<div class="inside">
										<p><label><input type="checkbox"> Recevoir un email avec les informations envoyées.</label></p>
										<blockquote ><p><label>Adresse email</label><input type="text" value=""></p></blockquote>
										
										<hr>
									</div>
								</div>
							</div>
						</div>
						<div id="postbox-container-1" class="postbox-container">
							<div class="meta-box">
								<!-- Texte -->
								<div class="postbox ">
									<div class="inside">
										<p>
											<label>Texte <small>(ligne)</small></label>
											<input type="text" disabled="disabled" placeholder="Saisissez votre texte ici" style="width:100%;" />
										</p>
									</div>
								</div>
								<!-- Textarea -->
								<div class="postbox ">
									<div class="inside">
										<p>
											<label>Texte <small>(bloc)</small></label>
											<textarea disabled="disabled" style="width:100%;">Saisissez votre texte ici</textarea>
										</p>
									</div>
								</div>
								<!-- Select -->
								<div class="postbox ">
									<div class="inside">
										<p>
											<label>Liste déroulante</label>
											<select disabled="disabled" style="width:100%;">
												<option>- Choisissez -</option>
											</select>
										</p>
									</div>
								</div>
								<!-- Radio -->
								<div class="postbox ">
									<div class="inside">
										<p>
											<label>Liste <small>(1 choix possible)</small></label>
											<ul class="categorychecklist">
												<li>
													<label class="selectit">
														<input type="radio" disabled="disabled">
														Choix 1
													</label>
												</li>
												<li>
													<label class="selectit">
														<input type="radio" disabled="disabled" checked="checked">
														Choix 2
													</label>
												</li>
											</ul>
										</p>
									</div>
								</div>
								<!-- Checkbox -->
								<div class="postbox ">
									<div class="inside">
										<p><label>Liste <small>(choix multiple)</small></label></p>
										<ul class="categorychecklist">
											<li>
												<label class="selectit">
													<input type="checkbox" disabled="disabled">
													Choix 1
												</label>
											</li>
											<li>
												<label class="selectit">
													<input type="checkbox" disabled="disabled" checked="checked">
													Choix 2
												</label>
											</li>
										</ul>
									</div>
								</div>
								<!-- Fichier -->
								<div class="postbox ">
									<div class="inside">
										<p>
											<label>Fichier</label>
											<input type="file" disabled="disabled">
										</p>
									</div>
								</div>
							</div>
						</div>
						<div id="postbox-container-2" class="postbox-container"></div>
					</div>
					<br class="clear">
				</div>
			</form>
		</div>
		<?php
	}
	
	
	// Fonction qui génère les formulaires
	function generate_form( $fields="", $trad="", $to="", $copy="" )
	{
		if ( empty( $fields ) || !is_array( $fields ) || empty( $trad ) || empty( $to ) )
			return false;
		
		global $_POST, $FILES, $_SESSION;
		
		$form = $msg 	= $enctype = "";
		$attachments	= array();
		$error			= false;
		
		$upload_path		= wp_upload_dir();
		$upload_dir			= $upload_path['basedir'].'/mgrm-forms/';
		
		// !Tentative d'envoi
		if ( !empty( $_POST ) )
		{
			//print "<pre>";
			//print_r( $_SESSION );
			//print "</pre>";
			//print "<pre>";
			//print_r( $_POST );
			//print "</pre>";
			
			// Vérifier ce qui est envoyé
			// --------------------------
			
			// Captcha
			$er_captcha = $_POST['captcha'] != $_SESSION['captcha'] ? true : false;
			if ( $er_captcha == 1 )
			{
				$error = true;
			}
			
			foreach( $fields as $field )
			{
				// !Nettoyer
				// ---------
				// Text
				if ( $field['type'] == 'text' || $field['type'] == 'textarea' )
				{
					if ( $field['name'] == 'email' )
					{
						${$field['name']}	= sanitize_email( $_POST[$field['name']] );	
						
					}else{
						${$field['name']}	= sanitize_text_field( $_POST[$field['name']] );
					}
				}
				
				// Select
				if ( $field['type'] == 'select' )
				{
					${$field['name']}	= $_POST[$field['name']];
				}
				
				// File
				if ( $field['type'] == 'file' )
				{
					${$field['name']}	= $_FILES[$field['name']];
				}
				
				
				// !Vérifier
				// ---------
				if ( $field['required'] )
				{	
					// Text
					if ( $field['type'] == 'text' || $field['type'] == 'textarea' )
					{
						if ( $field['name'] == 'email' )
						{
							${'er_'.$field['name']}	= !$this->is_email( ${$field['name']} );
						
						}else{
							${'er_'.$field['name']}	= empty( ${$field['name']} );
						}
					}
					
					// Select
					if ( $field['type'] == 'select' )
					{
						${'er_'.$field['name']}	= empty( ${$field['name']} );
					}
					
					// File
					if ( !$error && $field['type'] == 'file' )
					{
						${'er_'.$field['name']}	= 0;
						
						
						if ( $_FILES[$field['name']]['error'] > 0 ) // Problème de transfert du fichier
						{
							${'er_'.$field['name']}	= 1;
							
							${'er_txt_'.$field['name']} = $this->trad->file_error_1;
							
						}else{
									
							if ( $_FILES[$field['name']]['name'] != 'web.config' && $_FILES[$field['name']]['name'] != '.htaccess' )
							{
								
								if ( in_array( $_FILES[$field['name']]['type'], $field['filetypes'] ) )
								{
									
									$max_file_size	= $field['maxsize'] * 1024 * 1024;
									
									if ( $_FILES[$field['name']]['size'] > 0 && $_FILES[$field['name']]['size'] < $max_file_size )
									{
										
										if ( !is_dir( $upload_dir ) )
										{
											mkdir( $upload_dir );
										}
										
										$ext				= substr( $_FILES[$field['name']]['name'], strrpos( $_FILES[$field['name']]['name'], '.' ) );
										$new_file_name		= $upload_dir.md5( date( "YmdHisu" ) ).$ext;
										
										if( move_uploaded_file( $_FILES[$field['name']]['tmp_name'], $new_file_name ) )
										{	
											$img_infos	= getimagesize( $new_file_name );
											
											if ( !empty( $img_infos ) )
											{
												//print "<pre>";
												//print_r( $img_infos );
												//print "</pre>";
												
												$image = $new_file_name;
												if ( $source = @imagecreatefromjpeg( $image ) )
												{
													if ( imageJPEG( $source, $new_file_name ) )
													{
														array_push( $attachments, $new_file_name );
														
													}else{
														${'er_'.$field['name']}	= 1;
														${'er_txt_'.$field['name']} = $this->trad->file_error_2;
													}
													
												}else{
													${'er_'.$field['name']}	= 1;
													${'er_txt_'.$field['name']} = $this->trad->file_error_3;
												}
												
											}else{
												// L'image est corrompue
												${'er_'.$field['name']}	= 1;
												${'er_txt_'.$field['name']} = $this->trad->file_error_4;
											}
											
										}else{
											// Le fichier n'a pas pu être copié
											${'er_'.$field['name']}	= 1;
											${'er_txt_'.$field['name']} = $this->trad->file_error_2;
										}
									
									}else{
										// Le fichier est trop volumineux
										${'er_'.$field['name']}	= 1;
										${'er_txt_'.$field['name']} = $this->trad->file_error_5;
										
									}
									
								}else{ // Pas la bonne extension où fausse extension
									${'er_'.$field['name']}	= 1;
									${'er_txt_'.$field['name']} = $this->trad->file_error_3;
								}
										
							}else{
								// Le fichier à le même nom que le fichier de config
								${'er_'.$field['name']}	= 1;
								${'er_txt_'.$field['name']} = $this->trad->file_error_6;
							}
						}
					}
					
					if ( !isset(${'er_'.$field['name']}) || ${'er_'.$field['name']} == 1 )
					{
						if ( !isset(${'er_'.$field['name']}) )
						{
							${'er_'.$field['name']}	= 1;
							${'er_txt_'.$field['name']} = $this->trad->file_error_7;
						}
						
						$error = true;
					}
				}
			}
			
			
			// Si erreur, annuler et afficher un message
			if ( $error )
			{
				$msg	= $this->trad->form_error;
				
				
			// !Sinon envoyer le message et remettre les variables à zéro
			}else{
				$email_html = $this->generate_email( $fields, $trad, $copy );
				
				// Html pour les emails
				add_filter( 'wp_mail_content_type', array( $this, 'email_text_format' ) );
				
				// Send emails
				$send = wp_mail( mgrm_get_info('blogname').' <'.$to.'>', $trad->email_sujet, $email_html['body'], $email_html['headers'], $attachments );
				
				if ( $send )
				{
					// Supprimer les attachments
					foreach( $attachments as $attachment )
					{
						if ( is_file( $attachment ) )
						{
							unlink( $attachment );
						}
					}
					if( is_dir( $upload_dir ) && count( scandir( $upload_dir ) ) == 2 )
					{
						rmdir( $upload_dir );
					}
					
					// Save to db
					//$saved_messages	= get_option( $this->slug."-saved-messages" );
					//$saved_messages	= json_decode( $saved_messages );
					//
					//if ( empty( $saved_messages ) )
					//{
					//	$saved_messages	= array();
					//}
					//
					//$date	= new DateTime( 'Europe/Brussels' );
					//$date	= date_format( $date, 'YmdHis' );
					//$saved_messages[] = array(
					//	'date'		=> $date,
					//	'nom'		=> $nom,
					//	'prenom'	=> $prenom,
					//	'tel'		=> $tel,
					//	'email'		=> $user_email,
					//	'message'	=> $message
					//);
					//$saved_messages	= json_encode( $saved_messages );
					//update_option( $this->slug."-saved-messages", $saved_messages );
					
					// Message de confirmation
					$msg	= $this->trad->form_confirm;
				
					// Reset des variables
					foreach( $fields as $field )
					{
						${$field['name']} = ${'er_'.$field['name']} = "";
						$captcha = $er_captcha = "";
					}
					
				}else{
					$msg	= $this->trad->form_error_send;
				}
			}
		}
		
		// !Générer le formulaire
		foreach( $fields as $field )
		{
			$has_error	= isset( ${'er_'.$field['name']} ) && ${'er_'.$field['name']} ? " has-error" : "";
			
			// !Text
			if ( $field['type'] == 'text' )
			{
				$value	= isset( ${$field['name']} ) ? stripslashes( ${$field['name']} ) : '';
				
				$form	.= '<div class="form-group'.$has_error.'">
					<label class="control-label" for="'.$field['name'].'">'.$field['label'].'</label>
					<input type="text" class="form-control" id="'.$field['name'].'" name="'.$field['name'].'" value="'.$value.'">
				</div>';
			}
			
			// !Textarea
			if ( $field['type'] == 'textarea' )
			{
				$value	= isset( ${$field['name']} ) ? stripslashes( ${$field['name']} ) : '';
				
				$form	.= '<div class="form-group'.$has_error.'">
					<label class="control-label" for="'.$field['name'].'">'.$field['label'].'</label>
					<textarea class="form-control" rows="'.$field['rows'].'" id="'.$field['name'].'" name="'.$field['name'].'">'.$value.'</textarea>
				</div>';
			}
			
			// !Select
			if ( $field['type'] == 'select' )
			{
				$value		= isset( ${$field['name']} ) ? ${$field['name']} : '';
				$options	= "";
				
				if ( !empty( $field['values'] ) && is_array( $field['values'] ) )
				{
					foreach( $field['values'] as $key => $val )
					{
						$selected = !empty( $value ) && $value == $key ? ' selected="selected"' : '';
						
						$options	.= '<option value="'.$key.'"'.$selected.'>'.$val.'</option>';
					}
				}
				if ( !empty( $options ) )
				{
					$options = '<option value="">'.$this->trad->form_select_first.'</option>'.$options;
				}
				
				$form	.= '<div class="form-group'.$has_error.'">
					<label class="control-label" for="'.$field['name'].'">'.$field['label'].'</label>
					<select class="form-control" id="'.$field['name'].'" name="'.$field['name'].'">'.$options.'</select>
				</div>';
			}
			
			// !File
			if ( $field['type'] == 'file' )
			{
				$enctype	= ' enctype="multipart/form-data"';
				$label_more	= "";
				
				// Types de fichiers
				if ( isset( $field['filetypes'] ) && !empty( $field['filetypes'] ) && is_array( $field['filetypes'] ) )
				{
					$filetypes	= '';
					
					if ( in_array( 'image/jpeg', $field['filetypes'] ) )
					{
						$filetypes	.= '.jpg, .jpeg, ';
					}
					
					$filetypes = !empty( $filetypes ) ? substr( $filetypes, 0, -2 ) : '';
					$label_more	.= $filetypes;
				}
				
				// Taille max de fichier
				if ( isset( $field['maxsize'] ) && !empty( $field['maxsize'] ) )
				{
					$base = log( $field['maxsize'] * 1024 * 1024, 1024 );
					$suffixes = array('', 'k', 'M', 'G', 'T'); 
					$max_file_size_readable	= round(pow(1024, $base - floor($base)), 2) . $suffixes[floor($base)];
					
					$label_more	.= ' - max. '.$max_file_size_readable;
				}
				
				$label_more	= !empty( $label_more ) ? " <small>($label_more)</small>" : '';
				
				// Erreur fichier
				$error_file_txt	= isset( ${'er_txt_'.$field['name']} ) ? '<p class="text-warning">'.${'er_txt_'.$field['name']}.'</p>' : '';
				
				
				$value	= isset( ${$field['name']} ) ? ${$field['name']} : '';
				
				$form	.= '<div class="form-group'.$has_error.'">
					<label class="control-label" for="'.$field['name'].'">'.$field['label'].$label_more.'</label>
					<input type="file" class="" id="'.$field['name'].'" name="'.$field['name'].'" value="'.$value.'">
					'.$error_file_txt.'
				</div>';
			}
		}
		
		if ( !empty( $form ) )
		{
			// !Captcha
			$has_error	= isset( $er_captcha ) && $er_captcha ? " has-error" : "";
			
			$form	.= '<br>
				<div class="form-group'.$has_error.'">
					<label class="control-label" for="captcha">'.$this->trad->form_captcha.'</label>
					<input type="text" class="form-control" id="captcha" name="captcha" placeholder="'.$this->trad->form_captcha_ph.'">
					[mgrm-captcha]
				</div>';
			
			// Bouton submit
			$form	.= '<button type="submit" class="btn btn-submit">'.$this->trad->form_send.'</button>';
			
			// Ajouter la balise form
			$form_id	= !empty( $trad->title ) ? sanitize_title( $trad->title ) : '';
			$title		= !empty( $trad->title ) ? $trad->title : '';
			
			$form	= '<form id="form-'.$form_id.'" action="#form-'.$form_id.'" method="post" class="mgrm-forms"'.$enctype.'><h2>'.$title.'</h2>'.$msg.$form.'</form>';
			
			$form = do_shortcode( $form );
		}
		
		return $form;
	}
	function email_text_format ()
	{
		return 'text/html';
	}
	
	
	// Génère l'email
	function generate_email( $fields="", $trad="", $copy=""/*, $files=""*/ )
	{
		if ( empty( $fields ) || !is_array( $fields ) || empty( $trad ) )
			return false;
		
		global $_POST;
		
		// En têtes
		$from_email		= isset( $_POST['email'] ) ? $_POST['email'] : '';
		$from_nom		= isset( $_POST['nom'] ) ? $_POST['nom'] : 'Mediablog user';
		$from_prenom	= isset( $_POST['prenom'] ) ? $_POST['prenom'] : '';
		
		//$headers[] = 'Content-Type: text/html; charset=UTF-8';
		$headers[] = 'From: '.$from_prenom.' '.$from_nom.' <'.$from_email.'>';
		$headers[] = 'Cc: '.$from_prenom.' '.$from_nom.' <'.$from_email.'>';
		if ( !empty( $copy ) )
		{
			$headers[] = 'Bcc: <'.$copy.'>';
		}
		
		// Message html
		$body	= '<table align="center" bgcolor="#F5F5F5" cellpadding="0" cellspacing="0" width="600" style="border:1px solid #CCCCCC">';
		$body	.= '<tr><td width="20"></td><th align="left" valign="top">&nbsp;</th><td align="left" valign="top">&nbsp;</td><td width="20"></td></tr>';
		
		foreach( $fields as $field )
		{
			
			// Text, textarea
			if ( $field['type'] == 'text' || $field['type'] == 'textarea' )
			{
				$body	.= '<tr><td width="20"></td><th align="left" valign="top">';
				$body	.= stripslashes( $field['label'] );
				$body	.= '</th><td align="left" valign="top">';
				$body	.= wpautop( stripslashes( $_POST[$field['name']] ) );
				$body	.= '</td><td width="20"></td></tr>';
			}
			
			// Select
			if ( $field['type'] == 'select' )
			{
				$body	.= '<tr><td width="20"></td><th align="left" valign="top">';
				$body	.= stripslashes( $field['label'] );
				$body	.= '</th><td align="left" valign="top">';
				$body	.= stripslashes( $field['values'][$_POST[$field['name']]] );
				$body	.= '</td><td width="20"></td></tr>';
			}
		}
		
		$body	.= '<tr><td width="20"></td><th align="left" valign="top">&nbsp;</th><td align="left" valign="top">&nbsp;</td><td width="20"></td></tr>';
		$body	.= '</table><br><br><br>';
		$body	= '<html xmlns="http://www.w3.org/1999/xhtml"><html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>'.$trad->email_sujet.'</title></head><body>'.$body.'</body></html>';
		
		
		return array( "headers"	=> $headers, "body" => $body );
	}
	
	
	function is_email( $value ) {
		
		if ( empty( $value ) )
			return false;
		
		if ( preg_match( '|^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]{2,})+$|i', $value ) ) {
			return true;
			
		}
		return false;
	}
}