<?php
	
$mgrm_home = new mgrm_home;

class mgrm_home {
	
	var $slug	= "home";
	var $title	= "Page d'accueil";
	
	var $min_rights	= 'delete_others_pages';
	
	var $nbr_section			= 3;
	var $nbr_page_par_section	= 4;
	var $nbr_min_page			= 2;
	
	var $banner_w		= 1400;
	var $banner_h		= 300;
	var $banner_crop	= true;
	
	var $cur_lng	= "";
	
	
	// Construction de la classe
	function __construct()
	{
		$this->cur_lng		= mgrm_current_lng();
		
		add_image_size( 'mgrm_'.$this->slug, $this->banner_w, $this->banner_h, $this->banner_crop );
		
		if ( is_admin() )
		{
			// Ajouter la page d'admin
			add_action( 'admin_enqueue_scripts', array( $this, 'admin_js_css' ) );
			add_action( 'admin_menu', array( $this, 'add_admin_menu' ) );
		}
	}
	
	// Ajoute le js et css
	function admin_js_css( $current_screen )
	{		
		if ( $current_screen == 'couleur-cuisine_page_'.$this->slug )
		{
			$path = get_template_directory_uri().'/custom/'.$this->slug;
			
			//wp_enqueue_style( 'mgrm_'.$this->slug, $path.'css/custom.css' );
			
			wp_enqueue_script('jquery');
			
			//wp_enqueue_script('jcrop');
			//wp_enqueue_style('jcrop');
			
			wp_enqueue_media();
			
			wp_enqueue_script( 'mgrm_'.$this->slug, $path.'/js/'.$this->slug.'.js.php?bw='.$this->banner_w.'&bh='.$this->banner_h, array('jquery'), null, false );
		}
	}
	
	
	// Ajouter le menu dans l'admin
	function add_admin_menu ()
	{
		global $mgrm_infos;
		
		add_submenu_page( $mgrm_infos->slug, $this->title, $this->title, $this->min_rights, $this->slug, array( $this, "admin_page" ) );
	}
	
	
	// Affichage de la page d'admin
	function admin_page()
	{
		// Appeler la fonction pour enregistrer les changements
		if ( isset( $_POST['action'] ) && $_POST['action'] == 'update' )
		{
			$message = $this->update_changes();
		}
		
		// Récupérer les données
		$options	= get_option( 'mgrm_'.$this->slug );
		$options	= json_decode( $options );
		
		//print "<pre>";
		//print_r( $options );
		//print "</pre>";
		
		?>
		<div class="wrap">
			<h2><?php echo get_bloginfo( 'sitename' ); ?> - <small><?php echo $this->title; ?></small></h2>
			<br>
			<form action="" method="post">
				<input type="hidden" value="update" name="action">
				
				<?php
				for ( $j=1; $j<=$this->nbr_section; $j++ )
				{
				
				$s_num	= $j==1 ? $j.'<sup>ère</sup>' : $j.'<sup>ème</sup>';
					
				?>
				<h3>Pages à afficher dans la <?php echo $s_num; ?> section</h3>
				<p>Sélectionnez au minimum <?php echo $this->nbr_min_page; ?> pages pour que la section s'affiche.</p>
				<table class="widefat">
					<thead>
						<tr>
							<th>Page à afficher</th>
							<th>Définir un lien <small>(lier vers un autre contenu que la page sélectionnée)</small></th>
						</tr>
					</thead>
					<tbody>
						<?php
						for ( $i=1; $i<=$this->nbr_page_par_section; $i++ )
						{
							$prefix	= 's'.$j.'_p'.$i.'_';
							$class 	= !is_int( $i/2 ) ? ' class="alternate"' : '';
							
							// Valeurs enregistrées
							$selected	= "";
							$url		= "";
							$url_blank	= "";
							
							if ( isset( $options->{'s'.$j}->{$this->cur_lng} ) )
							{
								$selected	= isset( $options->{'s'.$j}->{$this->cur_lng}->{'p'.$i}->id )	? $options->{'s'.$j}->{$this->cur_lng}->{'p'.$i}->id		: '';
								$url		= isset( $options->{'s'.$j}->{$this->cur_lng}->{'p'.$i}->url )	? $options->{'s'.$j}->{$this->cur_lng}->{'p'.$i}->url		: '';
								$url_blank	= checked( $options->{'s'.$j}->{$this->cur_lng}->{'p'.$i}->blank, '1', false );
								
								if ( function_exists( 'pll_the_languages' ) && !empty( $selected ) )
								{
									$lng_selected	= pll_get_post( $selected );
									$selected	= !empty( $lng_selected ) ? $lng_selected : $selected;
								}
							}
						?>
						<tr<?php echo $class; ?>>
							<td>
							<?php
								wp_dropdown_pages(
									array(
										'show_option_none'	=> 'Choisissez',
										'option_none_value'	=> '0',
										'name'				=> $prefix.'id',
										'id'				=> $prefix.'id',
										'selected'			=> $selected,
									)
								);
							?>
							</td>
							<td>
								<input type="text" id="<?php echo $prefix; ?>url" name="<?php echo $prefix; ?>url" class="large-text" value="<?php echo $url; ?>" placeholder="http://...">
								<input type="checkbox" id="<?php echo $prefix; ?>blank" name="<?php echo $prefix; ?>blank" value="1"<?php echo $url_blank; ?>><label for="<?php echo $prefix; ?>blank"><small>Ouvrir dans une nouvelle fenêtre</small></label>
							</td>
						</tr>
						<?php } ?>
					</tbody>
				</table>
				
				
				<?php
				if ( $j < $this->nbr_section ) :
					
					$img_id	= isset( $options->{'s'.$j}->{$this->cur_lng}->img->id ) ? $options->{'s'.$j}->{$this->cur_lng}->img->id : '';
					//$img_x1	= isset( $options->{'s'.$j}->img->x1 ) ? $options->{'s'.$j}->img->x1 : '';
					//$img_y1	= isset( $options->{'s'.$j}->img->y1 ) ? $options->{'s'.$j}->img->y1 : '';
					//$img_x2	= isset( $options->{'s'.$j}->img->x2 ) ? $options->{'s'.$j}->img->x2 : '';
					//$img_y2	= isset( $options->{'s'.$j}->img->y2 ) ? $options->{'s'.$j}->img->y2 : '';
					
					$img_elem	= "";
					$img_script	= "";
					if ( !empty( $img_id ) )
					{
						$img_elem	= wp_get_attachment_image_src( $img_id, 'mgrm_'.$this->slug ); //, '', array( 'width' => '1000', 'height' => 'auto', 'id' => 'img_'.$img_id )
						$img_elem	= '<img src="'.$img_elem[0].'" width="1000" id="img_'.$img_id.'">';
						
						//$img_script	= '<script>jQuery( "img#img_'.$img_id.'" ).Jcrop({
						//				onSelect	: setCoords,
						//				aspectRatio	: '.$this->banner_w.'/'.$this->banner_h.',
						//				setSelect	: [ '.$img_x1.', '.$img_y1.', '.$img_x2.', '.$img_y2.' ]
						//			});</script>';
					}
				?>
				
				<h3>Image de séparation</h3>
				<p>Veuillez sélectionner une image qui fait au minimum <?php echo $this->banner_w; ?> pixels de large et <?php echo $this->banner_h; ?> pixels de haut.</p>
				<div>
					<input type="button" class="button media-browser" value="Sélectionner une image" /> <input type="button" class="button media-remove" value="Retirer l'image" />
					<input type="hidden" id="s<?php echo $j; ?>_img_id" name="s<?php echo $j; ?>_img_id" value="<?php echo $img_id; ?>">
					<?php /*<input type="hidden" id="s<?php echo $j; ?>_img_x1" name="s<?php echo $j; ?>_img_x1" value="<?php echo $img_x1; ?>">
					<input type="hidden" id="s<?php echo $j; ?>_img_y1" name="s<?php echo $j; ?>_img_y1" value="<?php echo $img_y1; ?>">
					<input type="hidden" id="s<?php echo $j; ?>_img_x2" name="s<?php echo $j; ?>_img_x2" value="<?php echo $img_x2; ?>">
					<input type="hidden" id="s<?php echo $j; ?>_img_y2" name="s<?php echo $j; ?>_img_y2" value="<?php echo $img_y2; ?>"> */ ?>
					<br><br>
					<?php echo $img_elem.$img_script; ?>
				</div>
				
				<?php endif; ?>
				
				<br>
				
				<?php } ?>
				<p class="submit"><input id="submit" class="button button-primary" type="submit" value="Enregistrer les modifications" name="submit"></p>
			</form>
		</div>
		<?php
	}
	
	function update_changes()
	{
		$options	= get_option( 'mgrm_'.$this->slug );
		$options	= json_decode( $options );
		
		// Sections
		for ( $j=1; $j<=$this->nbr_section; $j++ )
		{
			
			// Pages
			for ( $i=1; $i<=$this->nbr_page_par_section; $i++ )
			{
				$prefix	= 's'.$j.'_p'.$i.'_';
				
				$options->{'s'.$j}->{$this->cur_lng}->{'p'.$i}->id = isset( $_POST[$prefix.'id'] ) ? $_POST[$prefix.'id'] : '0';
				$options->{'s'.$j}->{$this->cur_lng}->{'p'.$i}->url = isset( $_POST[$prefix.'url'] ) && !empty( $_POST[$prefix.'url'] ) ? $_POST[$prefix.'url'] : "";
				$options->{'s'.$j}->{$this->cur_lng}->{'p'.$i}->blank = isset( $_POST[$prefix.'blank'] ) ? $_POST[$prefix.'blank'] : '0';
			}
			
			// Enregistrer l'image
			if ( $j < $this->nbr_section )
			{
				$options->{'s'.$j}->{$this->cur_lng}->img->id	= $_POST['s'.$j.'_img_id'];
				//$options->{'s'.$j}->img->x1	= $_POST['s'.$j.'_img_x1'];
				//$options->{'s'.$j}->img->y1	= $_POST['s'.$j.'_img_y1'];
				//$options->{'s'.$j}->img->x2	= $_POST['s'.$j.'_img_x2'];
				//$options->{'s'.$j}->img->y2	= $_POST['s'.$j.'_img_y2'];
				
				// Enregistrer l'image recadrée
				//$ratio	= $this->banner_w/1000;
				//$x1	= $_POST['s'.$j.'_img_x1']*$ratio;
				//$y1	= $_POST['s'.$j.'_img_y1']*$ratio;
				//$x2	= $_POST['s'.$j.'_img_x2']*$ratio;
				//$y2	= $_POST['s'.$j.'_img_y2']*$ratio;
				//$dw = $x2 - $x1;
				//$dh	= $y2 - $y1;
				//
				//$upload_dir			= wp_upload_dir();
				//$original_image		= wp_get_attachment_metadata( $_POST['s'.$j.'_img_id'], 'full' );
				//
				//$banner_image		= wp_get_image_editor( $upload_dir['basedir'].'/'.$original_image['file'] );
				//$banner_path		= substr( $original_image['file'], 0, strrpos( $original_image['file'], '/' ) );
				//$banner_ext			= substr( $original_image['file'], strrpos( $original_image['file'], "." ) );
				//$banner_filename	= substr( $original_image['file'], strrpos( $original_image['file'], '/' ), strrpos( $original_image['file'], "." )-strrpos( $original_image['file'], '/' ) );
				//$new_filename	= $upload_dir['basedir'].'/'.$banner_path.$banner_filename.'-'.$this->banner_w.'x'.$this->banner_h.$banner_ext;
				//
				///*if ( ! is_wp_error( $banner_image ) ) {
				//	$banner_image->crop( $x1, $y1, $dw, $dh, NULL, NULL, false );
				//	$banner_image->resize( $imgw, NULL, false );
				//	$banner_image->set_quality( 65 );
				//	$banner_image->save( $new_filename );
				//	chmod( $new_filename, 0777 );
				//}*/
			}
		}
		
		//print "<pre>";
		//print_r( $options );
		//print "</pre>";
		
		$options	= json_encode( $options );
		update_option( 'mgrm_'.$this->slug, $options );
	}
	
}


/*
 * Afficher les articles d'une section
 *
 * $section_num | int : numéro de la section
 * $thumbnails | boolean : afficher le thumbnail
 * $more | boolean : afficher le texte du lien vers l'article
 */
function mgrm_home_get_section( $section_num=0, $thumbnails=true, $more=true )
{
	// Si 0 on annule
	if ( $section_num == 0 )
		return;
	
	global $mgrm_home;
	
	$options	= get_option( 'mgrm_'.$mgrm_home->slug );
	$options	= json_decode( $options );
	
	$cur_lng		= mgrm_current_lng();
	
	// Si la section n'existe pas on annule
	if ( !isset( $options->{'s'.$section_num} ) )
		return;
		
	// Si la langue est définie on annule
	if ( !isset( $options->{'s'.$section_num}->$cur_lng ) )
		return;
	
	// Si il y a moins de 2 page sélectionnée on annule
	$section		= $options->{'s'.$section_num};
	$id_count		= 0;
	
	for ( $i=1; $i<=$mgrm_home->nbr_page_par_section; $i++ )
	{
		$pid	= $section->$cur_lng->{'p'.$i}->id;
		
		if ( $section->$cur_lng->{'p'.$i}->id != 0 )
		{
			$id_count++;
		}
	}
	if ( $id_count < $mgrm_home->nbr_min_page )
		return;
	
	// Afficher les pages
	$section_content	= "";
	$col_size	= 12/$id_count;
	
	for ( $i=1; $i<=$mgrm_home->nbr_page_par_section; $i++ )
	{
		$pid	= $section->$cur_lng->{'p'.$i}->id;
		// Récupérer la traduction
		if ( function_exists( 'pll_the_languages' ) )
		{
			$tr_pid	= pll_get_post( $pid );
			if ( !empty( $tr_pid ) )
			{
				$pid	= $tr_pid;
			}
		}
		
		if ( $section->$cur_lng->{'p'.$i}->id != 0 )
		{
			$ptitle		= get_post_field( 'post_title', $pid );
			$pexcerpt	= mgrm_get_the_excerpt( $pid );
			$pthumbnail	= get_the_post_thumbnail( $pid, 'large' );
			$ppermalink	= get_permalink( $pid );
			
			$section_content	.= '<div class="col-sm-'.$col_size.'">';
			$section_content	.= '<a href="'.$ppermalink.'">';
			$section_content	.= '<span class="post-title">'.$ptitle.'</span>';
			$section_content	.= '<span class="post-excerpt">'.$pexcerpt.'</span>';
			if ( $thumbnails )
			{
				$section_content	.= '<span class="post-thumbnail">'.$pthumbnail.'</span>';
			}
			if ( $more )
			{
				$section_content	.= '<a class="more-lnk btn" href="'.$ppermalink.'">'.__( 'Read more...' ).'</a>';
			}
			$section_content	.= '</a></div>';
		}
	}
	
	$section_content	.= '<div class="clearfix"></div>';
	
	return $section_content;
}


/*
 * Afficher l'image d'une section
 *
 * $section_num | int : numéro de la section
 */
function mgrm_home_get_section_img( $section_num=0 )
{
	// Si 0 on annule
	if ( $section_num == 0 )
		return;
	
	global $mgrm_home;
	
	$options	= get_option( 'mgrm_'.$mgrm_home->slug );
	$options	= json_decode( $options );
	
	$cur_lng		= mgrm_current_lng();
	
	// Si la section n'existe pas on annule
	if ( !isset( $options->{'s'.$section_num} ) )
		return;
		
	// Si la langue est définie on annule
	if ( !isset( $options->{'s'.$section_num}->$cur_lng ) )
		return;
	
	// Si l'id n'est pas défini ou qu'il est vide on annule
	if ( !isset( $options->{'s'.$section_num}->$cur_lng->img->id ) || empty( $options->{'s'.$section_num}->$cur_lng->img->id ) )
		return;
	
	$img_elem	= wp_get_attachment_image( $options->{'s'.$section_num}->$cur_lng->img->id, 'mgrm_'.$mgrm_home->slug );
	if ( empty( $img_elem ) )
		return;
	
	return $img_elem;
}