<?php

// Définir les fonctionnalités de base
if ( ! function_exists( 'mgrm_setup' ) )
{
	function mgrm_setup()
	{
		// Styles de l'éditeur
		add_editor_style( array( 'css/bootstrap.min.css', 'css/editor.min.css' ) );
		
		// Activer les images à la une et les tailles d'images
		//add_theme_support( 'post-thumbnails' );
		set_post_thumbnail_size( 1020, 680, true );
		
		// Compresser les images plus fort !
		add_filter( 'jpeg_quality', create_function( '', 'return 75;' ) );
		
		// Activer les menus
		register_nav_menus( array(
			'primary'   => 'Header',
			//'secondary' => 'Menu secondaire',
		) );
	}
}
add_action( 'after_setup_theme', 'mgrm_setup' );


// Ajouter les styles et les scripts
function mgrm_enqueue_scripts()
{
	
	// CSS bootstrap
	wp_enqueue_style( 'bootstrap', get_template_directory_uri().'/css/bootstrap.min.css', array(), null );
	
	// CSS reset
	wp_enqueue_style( 'fontawesome', get_template_directory_uri().'/css/font-awesome.min.css', array(), null );
	
	// CSS
	wp_enqueue_style( 'mgrm_main', get_template_directory_uri().'/css/main.min.css?d='.date("YmdHis"), array(), null );
	
	
	// JS html5shiv
	wp_enqueue_script( 'mgrm_html5shiv', get_template_directory_uri().'/js/html5shiv.js', array(), null, false );
	
	// JS jquery
	wp_enqueue_script( 'jquery' );
	
	// JS bootstrap
	wp_enqueue_script( 'mgrm_bootstrap', get_template_directory_uri().'/js/bootstrap.min.js', array(), null, false );
	
	// CSS/JS nivo slider
	//wp_enqueue_style( 'nivo_slider', get_template_directory_uri().'/js/nivo-slider/nivo-slider.css', array(), null );
	//wp_enqueue_script( 'nivo_slider', get_template_directory_uri().'/js/nivo-slider/jquery.nivo.slider.pack.js', array( 'jquery' ), null, false );
	
	// JS
	wp_enqueue_script( 'mgrm_custom', get_template_directory_uri().'/js/custom.min.js', array( 'jquery' ), null, false );
}
add_action( 'wp_enqueue_scripts', 'mgrm_enqueue_scripts' );


// Retirer le meta generator
remove_action('wp_head', 'wp_generator');


// Inclure les fichiers du thème
include( 'custom/admin.php' );

include( 'custom/bootstrap.php' );
include( 'custom/lng.php' );
include( 'custom/menus.php' );
include( 'custom/content.php' );
include( 'custom/galleries.php' );
include( 'custom/captcha.php' );
include( 'custom/formulaires.php' );
include( 'custom/alaune.php' );

include( 'custom/infos.php' );
//include( 'custom/home.php' );
//include( 'custom/banners.php' );
//include( 'custom/bloc_top.php' );
include( 'custom/bloc_home.php' );
//include( 'custom/newsletter.php' );
include( 'custom/fond.php' );

include( 'custom/editor/full_width_img/full_width_img.php' );
include( 'custom/editor/full_bg_color/full_bg_color.php' );