<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
	<meta charset="<?php bloginfo( 'charset' ); ?>" />
	<meta name="viewport" content="width=device-width, initial-scale=1">
	
	<title><?php wp_title( '|', true, 'right' ); echo mgrm_get_info('blogname').' - '.mgrm_get_info('blogdescription'); ?></title>
	
	<link rel="profile" href="http://gmpg.org/xfn/11" />
	<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
	
	<meta property="og:url"                content="<?php echo esc_url( home_url( '/' ) ); ?>" />
	<meta property="og:type"               content="website" />
	<meta property="og:title"              content="<?php wp_title( '|', true, 'right' ); echo mgrm_get_info('blogname'); ?>" />
	<meta property="og:description"        content="<?php echo mgrm_get_info('blogdescription'); ?>" />
	<meta property="og:image"              content="<?php echo get_template_directory_uri(); ?>/images/logo.png" />
	
	<?php 
	wp_head();
	?>
</head>

<body <?php body_class(); ?>>

	<div id="fb-root"></div>
	<script>(function(d, s, id) {
	  var js, fjs = d.getElementsByTagName(s)[0];
	  if (d.getElementById(id)) return;
	  js = d.createElement(s); js.id = id;
	  js.src = "//connect.facebook.net/fr_FR/sdk.js#xfbml=1&version=v2.6&appId=255758008100876";
	  fjs.parentNode.insertBefore(js, fjs);
	}(document, 'script', 'facebook-jssdk'));</script>

	<div id="bg-header"></div>
	<div id="bg-flammes"></div>

	<header class="main">
		
		<nav class="navbar navbar-default">
			
			<div class="container">
				
				<!-- Logo -->
				<div class="navbar-header">
					<button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#header-menu-collapse">
						<span class="sr-only">Toggle navigation</span>
						<span class="icon-bar"></span>
						<span class="icon-bar"></span>
						<span class="icon-bar"></span>
					</button>
					<a class="navbar-brand" href="<?php echo esc_url( home_url( '/' ) ); ?>">
						<img src="<?php echo get_template_directory_uri(); ?>/images/logo.png" alt="<?php echo mgrm_get_info('blogname').' - '.mgrm_get_info('blogdescription'); ?>">
					</a>
				</div>
				
				<div class="collapse navbar-collapse" id="header-menu-collapse">
					
					<!-- Menu principal -->
					<?php
					wp_nav_menu( array(
						'theme_location'=> 'primary',
		                'depth'			=> 2,
		                'container'		=> false,
		                'menu_class'	=> '',
		                'items_wrap'	=> '<ul id="header-menu" class="nav navbar-nav">%3$s</ul>',
		                'walker'		=> new wp_bootstrap_navwalker())
		            );
		            ?>
				</div>
				
			</div>
			
		</nav>
		
		<div id="reseaux-social">
			<div class="container">
				<div class="fb-like" data-href="http://www.sebetec.be/" data-layout="button_count" data-action="like" data-show-faces="false" data-share="true"></div>
			</div>
		</div>
		
	</header>